using Distributions,Printf
using DelimitedFiles
using DataFrames,CSV
using SparseArrays
using LinearAlgebra
using ProgressMeter
using .PedModule
using .misc

include("types.jl")
include("printout.jl")
include("solver.jl")
include("random_effects.jl")
include("build_MME.jl")
include("residual.jl")
include("MCMC/MCMC.jl")
include("markers/markers.jl")
include("variance.jl")
include("Pi.jl")

include("misc/misc.jl")
include("pipeline/LOOCV.jl")
include("pipeline/adjust_phenotype.jl")

export build_model,set_covariate,set_random,add_genotypes,add_markers
export outputMCMCsamples,outputEBV,getEBV
export solve,runMCMC
export showMME,getinfo
#Pedmodule
export get_pedigree
#misc
export GWAS,QC
export get_additive_genetic_variances,get_breeding_values
export get_correlations,get_heritability
#others
export adjust_phenotypes,LOOCV
